Index: tag/rc_1/jouanny2/main.c
===================================================================
--- tag/rc_1/jouanny2/main.c	(nonexistent)
+++ tag/rc_1/jouanny2/main.c	(revision 426)
@@ -0,0 +1,240 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include "trame.h"
+
+#define Rt 6400 /*rayon de la terre*/
+//Trames de tests à modifier si nécessaire.
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+typedef struct{
+    float Lat; /* latitude */
+    float Lon; /* lontitude */
+} Position;
+
+
+int trame_cmp(char *trame, char *type)
+{
+    int i,b=1;
+
+    for (i=0;i<5;i++)
+    {
+        if (trame[i+1]!=type[i])
+            {
+                b=0;
+            }
+    }
+    return b;
+}
+
+int decode_int(char *c)
+{
+    int nb;
+
+    if (c>=48 && c<=57)
+    {
+        nb=c-48;
+    }
+    else
+    {
+        nb=-1;
+    }
+
+    return nb;
+}
+
+int decode_nombre(char *ch, int i, int n) /* fonction qui permet de passer d'une chaine de caractere a un entier */
+{
+    int res=0; /* initialisation du resultat=0 */
+
+    for (i; i<=n; i++)
+    {
+        res=10*res + decode_int(ch[i]); /* permet de reconstituer le nombre terme a terme par puissance de 10 */
+    }
+    return res;
+}
+
+float decode_latitude(char *trame) /* fonction convertissant la chaîne de caractère contenant la latitude en nombre flottant et son test unitaire */
+{
+    float res_decode_Lat, res1, res2, res3;
+
+    res1 = decode_nombre(trame,17,18);      //retrouver les degrés en sexagesimal dans la trame
+    res2 = decode_nombre(trame,19,20);      //retrouver les minutes en sexagesimal dans la trame
+    res3 = decode_nombre(trame,22,25);      //retrouver les secondes en sexagesimal dans la trame
+
+    res_decode_Lat = res1 + (res2 + res3/10000)/60;    //conversion sexagesimal à degrés
+
+    if(trame[27]=='S')     //identifier si la latitude est nord ou sud
+    {
+        res_decode_Lat = -res_decode_Lat;
+    }
+
+    return res_decode_Lat;
+}
+
+
+float decode_longitude(char *trame) /* fonction convertissant la chaîne de caractère contenant la longitude en nombre flottant et son test unitaire */
+{
+    float res_decode_Lon, res1, res2, res3;
+
+    res1 = decode_nombre(trame,30,31);
+    res2 = decode_nombre(trame,32,33);
+    res3 = decode_nombre(trame,35,38);
+
+    res_decode_Lon = res1 + (res2 + res3/10000)/60;
+
+    if(trame[39]=='W')     //identifier si la latitude est ouest ou est
+    {
+        res_decode_Lon = -res_decode_Lon;
+    }
+
+    return res_decode_Lon;
+}
+
+
+Position decode_position(char *trame) /* fonction qui décode indifféremment une latitude ou une longitude */
+{
+    Position pos;
+
+    pos.Lat = decode_latitude(trame);
+    pos.Lon = decode_longitude(trame);
+
+    return pos;
+}
+
+float decode_trame(char *trame)/*fonction qui affiche la latitude et la longitude*/
+{
+    Position pos;
+
+    decode_position(*trame);
+    printf("%f", pos.Lat);
+    printf("%f", pos.Lon);
+}
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires(void){
+    Position pos;
+
+    if (5!=5){
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
+    }
+    /*if (trame_cmp("$GPGGA suite chaine","GPGGA")==0)
+    {
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC suite chaine","GPGGA")==1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC... ", "GPRMC" )==0){
+        printf ("Erreur Test unitaire trame_cmp.\n");    if (decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lat != 45.75)
+    {
+        printf ("Erreur test unitaire decode_longitude-2\n");
+        exit(-1);
+    }
+
+        exit(-1);
+    }
+    if (trame_cmp("$APRMC...", "GPGGA")==0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }*/
+    /*if (decode_int("7")!=-1)
+    {
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }*/
+    /*test_decode_nombre();*/
+    if (decode_latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D") != 45.75)
+    {
+        printf ("Erreur test unitaire decode_latitude\n");
+        exit(-1);
+    }
+    if (decode_longitude("$GPGGA,141914.00,4545.0000,N,00345.0000,E,1,05,3.4,499.3,M,,M,,*7D") != 3.75)
+    {
+        printf ("Erreur test unitaire decode_longitude\n");
+        exit(-1);
+    }
+    /*if (decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lon != 3.1100599765777588)
+    {
+        printf ("Erreur test unitaire decode_longitude-1\n");
+        exit(-1);
+    }
+    if (decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lat != 45.75)
+    {
+        printf ("Erreur test unitaire decode_longitude-2\n");
+        exit(-1);
+    }*/
+}
+
+void test_decode_nombre()
+{
+    char t[5];
+    t[0] = '1'; t[1] = '2'; t[2] = '3'; t[3] = '4';/*initialisation de la trame test*/
+
+    if (decode_nombre(t,0,0) != 1)
+    {
+        printf ("Erreur test unitaire decode_nombre_1\n");
+        exit(-1);
+    }
+
+    if (decode_nombre(t,0,3) != 1234)
+    {
+        printf ("Erreur test unitaire decode_nombre_2\n");
+        exit(-1);
+    }
+    if (decode_nombre(t,0,3) != 1357)
+    {
+        printf ("Erreur test unitaire decode_nombre_3\n");
+        exit(-1);
+    }
+}
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+    static int cpt=0;
+    Position pos;
+
+    if (trame_cmp(trame, "GPGGA")==1)
+    {
+        printf("> %s", trame);
+        /*decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D");*/
+        decode_position(trame);
+        printf("%f\n", pos.Lat);
+        printf("%f\n\n", pos.Lon);
+        cpt++;
+    }
+}
+// Ne pas modifier cette fonction
+int main(int argc,char ** argv)
+{
+
+    tests_unitaires();
+
+    // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+
+    return 0;
+}
Index: tag/rc_1/jouanny2/gps.log
===================================================================
--- tag/rc_1/jouanny2/gps.log	(nonexistent)
+++ tag/rc_1/jouanny2/gps.log	(revision 426)
@@ -0,0 +1,111 @@
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E
+$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C
+$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E
+$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,99.4,T,,M,0.4,N,0.7,K*57
+$GPZDA,141914.00,01,02,2006,00,00*69
+$GPGSV,3,1,10,01,13,142,46,03,48,144,47,11,41,277,,14,27,104,42*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141915.00,A,4545.6423,N,00306.6039,E,0.6,110.2,010206,,*31
+$GPGLL,4545.6423,N,00306.6039,E,141915.00,A*07
+$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,110.2,T,,M,0.6,N,1.2,K*67
+$GPZDA,141915.00,01,02,2006,00,00*68
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,49,28,15,320,*76
+$GPRMC,141916.00,A,4545.6422,N,00306.6037,E,0.1,211.1,010206,,*3B
+$GPGLL,4545.6422,N,00306.6037,E,141916.00,A*0B
+$GPGGA,141916.00,4545.0484,N,00306.6037,E,1,05,3.4,500.0,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,211.1,T,,M,0.1,N,0.2,K*60
+$GPZDA,141916.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,43*78
+$GPGSV,3,2,10,15,03,077,,18,04,041,44,19,85,271,,20,08,214,*7A
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141917.00,A,4545.6422,N,00306.6039,E,0.3,122.3,010206,,*37
+$GPGLL,4545.6422,N,00306.6039,E,141917.00,A*04
+$GPGGA,141917.00,4545.0726,N,00306.6039,E,1,05,3.4,499.6,M,,M,,*73
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,122.3,T,,M,0.3,N,0.5,K*64
+$GPZDA,141917.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,41*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141918.00,A,4545.6421,N,00306.6034,E,0.5,252.2,010206,,*35
+$GPGLL,4545.6421,N,00306.6034,E,141918.00,A*05
+$GPGGA,141918.00,4545.0968,N,00306.6034,E,1,05,3.4,498.8,M,,M,,*7A
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,252.2,T,,M,0.5,N,1.0,K*63
+$GPZDA,141918.00,01,02,2006,00,00*65
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,42*79
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141919.00,A,4545.6420,N,00306.6040,E,0.6,95.2,010206,,*0C
+$GPGLL,4545.6420,N,00306.6040,E,141919.00,A*06
+$GPGGA,141919.00,4545.1210,N,00306.6040,E,1,05,3.4,500.2,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,95.2,T,,M,0.6,N,1.2,K*5B
+$GPZDA,141919.00,01,02,2006,00,00*64
+$GPGSV,3,1,10,01,13,142,46,03,48,144,49,11,41,277,,14,27,104,42*7B
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141920.00,A,4545.6419,N,00306.6039,E,0.2,133.1,010206,,*38
+$GPGLL,4545.6419,N,00306.6039,E,141920.00,A*08
+$GPGGA,141920.00,4545.1410,N,00306.6039,E,1,05,3.4,500.0,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,133.1,T,,M,0.2,N,0.4,K*66
+$GPZDA,141920.00,01,02,2006,00,00*6E
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,43*76
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,50,28,15,320,*7F
+$GPRMC,141921.00,A,4545.6419,N,00306.6043,E,0.6,103.1,010206,,*33
+$GPGLL,4545.6419,N,00306.6043,E,141921.00,A*04
+$GPGGA,141921.00,4545.1610,N,00306.6043,E,1,05,3.4,499.8,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,103.1,T,,M,0.6,N,1.1,K*65
+$GPZDA,141921.00,01,02,2006,00,00*6F
+$GPGSV,3,1,10,01,13,142,46,03,48,144,48,11,41,277,,14,27,104,42*7A
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141922.00,A,4545.6418,N,00306.6046,E,0.7,96.9,010206,,*00
+$GPGLL,4545.6418,N,00306.6046,E,141922.00,A*03
+$GPGGA,141922.00,4545.1810,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,96.9,T,,M,0.7,N,1.3,K*53
+$GPZDA,141922.00,01,02,2006,00,00*6C
+$GPGSV,3,1,10,01,13,142,47,03,48,144,46,11,41,277,,14,27,104,43*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141923.00,A,4545.6417,N,00306.6046,E,0.3,113.6,010206,,*39
+$GPGLL,4545.6417,N,00306.6046,E,141923.00,A*0D
+$GPGGA,141923.00,4545.2010,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*7D
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,113.6,T,,M,0.3,N,0.7,K*61
+$GPZDA,141923.00,01,02,2006,00,00*6D
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141924.00,A,4545.6416,N,00306.6044,E,0.2,197.7,010206,,*31
+$GPGLL,4545.6416,N,00306.6044,E,141924.00,A*09
+$GPGGA,141924.00,4545.2210,N,00306.6044,E,1,05,3.4,500.5,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,197.7,T,,M,0.2,N,0.4,K*6E
+$GPZDA,141924.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141925.00,A,4545.6415,N,00306.6046,E,0.2,130.8,010206,,*33
+$GPGLL,4545.6415,N,00306.6046,E,141925.00,A*09
+$GPGGA,141925.00,4545.2410,N,00306.6046,E,1,05,3.4,501.4,M,,M,,*7C
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,130.8,T,,M,0.2,N,0.5,K*6D
+$GPZDA,141925.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,47,28,15,320,*79
+$GPRMC,141926.°E,0.2,260.8,010206,,*34
Index: tag/rc_1/jouanny2/trame.c
===================================================================
--- tag/rc_1/jouanny2/trame.c	(nonexistent)
+++ tag/rc_1/jouanny2/trame.c	(revision 426)
@@ -0,0 +1,28 @@
+/* Fichier trames.c - Gestion et decodage des trames */
+/* Ce fichier sera fourni */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "trame.h"
+
+#define FICHIER_TRAMES "gps.log"  /* Par exemple */
+
+#define MAX_FRAME_LENGTH 80
+
+static char trame_buf[MAX_FRAME_LENGTH];
+static FILE *trame_fic;
+
+int trame_init(void)
+{
+    trame_fic = fopen(FICHIER_TRAMES, "r");
+    if (trame_fic)
+        return 1;
+
+    fprintf(stderr, "Impossible d'ouvrir le fichier %s\n", FICHIER_TRAMES);
+    return 0;
+}
+
+char *trame_suivante(void)
+{
+  return fgets(trame_buf, MAX_FRAME_LENGTH-1, trame_fic);
+}
Index: tag/rc_1/jouanny2/sp4a.cbp
===================================================================
--- tag/rc_1/jouanny2/sp4a.cbp	(nonexistent)
+++ tag/rc_1/jouanny2/sp4a.cbp	(revision 426)
@@ -0,0 +1,37 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
+<CodeBlocks_project_file>
+	<FileVersion major="1" minor="6" />
+	<Project>
+		<Option title="sp4a" />
+		<Option pch_mode="2" />
+		<Option compiler="gcc" />
+		<Build>
+			<Target title="Debug">
+				<Option output="sp4a" prefix_auto="1" extension_auto="1" />
+				<Option object_output=".\debug" />
+				<Option type="1" />
+				<Option compiler="gcc" />
+				<Compiler>
+					<Add option="-g" />
+				</Compiler>
+			</Target>
+		</Build>
+		<Compiler>
+			<Add option="-Wall" />
+		</Compiler>
+		<Unit filename="gps.log" />
+		<Unit filename="main.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.h" />
+		<Extensions>
+			<code_completion />
+			<envvars />
+			<debugger />
+			<lib_finder disable_auto="1" />
+		</Extensions>
+	</Project>
+</CodeBlocks_project_file>
Index: tag/rc_1/jouanny2/trame.h
===================================================================
--- tag/rc_1/jouanny2/trame.h	(nonexistent)
+++ tag/rc_1/jouanny2/trame.h	(revision 426)
@@ -0,0 +1,3 @@
+
+int trame_init(void);
+char * trame_suivante(void);