Index: tag/rc_1/ROCHE/main.c
===================================================================
--- tag/rc_1/ROCHE/main.c	(nonexistent)
+++ tag/rc_1/ROCHE/main.c	(revision 438)
@@ -0,0 +1,414 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include "trame.h"
+#include <math.h>
+
+//Trames de tests à modifier si nécessaire.
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+typedef struct {      //Definition de la structure position
+	float latitude;
+	float longitude;
+} Position ;
+
+typedef struct {        //Definition de la structure zone
+    Position rpos;
+    float vitmax;
+} Zone;
+
+Position P1,P2; //Iniatialisation des structures pos 1 et 2
+
+Zone zones[] = {   //Iniatlisation du tableau de structure Zones
+        {{44.7891220,-3.013},50},
+        {{44.7887762,-3.012},70}
+};
+
+
+
+
+int trame_cmp(char * trame, char * type) {
+	int i=1; //Pour commencer apres le $ de la trame
+	int res=1;
+
+	do
+    {
+		if (trame[i]==type[i-1]) { //verifie si la trame est GPGGA
+			i++;
+		}
+		else {
+			res=0;
+		}
+    }
+	while ((res!=0) && (i<6)); //on analyse le premier GP...
+	return (res);
+}
+
+int decode_int(char c) {
+	int i;
+    i=c-48; //conversion char ascii en nombre entier
+    if (i>9) { //verif si le char est un chiffre
+        return (-1);
+        }
+    else {
+        return(i);
+    }
+}
+
+int decode_nombre(char * ch, int n) { //permet de decode un nombre de + 1 chiffre
+    int i=0,res=0,b,p;
+	for (i=0;i<n;i++) {
+        p=1;
+        for(b=0;b<n-i-1;b++){ //joue le role d'une puissance
+            p=p*10;
+        }
+		res = res + decode_int(ch[i])*p;
+	}
+	return res;
+}
+
+
+float decode_lat_long (char c[]) {
+    int n=0, degre=0,i=1,b;
+    float min=0, secondes=0, res=0,p;
+
+
+    do{
+        n++;
+    } while (c[n]!='.');
+
+    if (n==4) { //Travaille une latitude
+        degre = (c[0]-48)*10+(c[1]-48); //partie degré d'une lat
+        min = (c[2]-48)*10+(c[3]-48); //partie min d'une lat
+    } else { //Travaille une longitude
+        degre = (c[0]-48)*100+(c[1]-48)*10+(c[2]-48);
+        min = (c[3]-48)*10+(c[4]-48);
+    }
+
+    n++;
+    do {
+        p=1;
+        for (b=0;b<i;b++) { //permet de faire des 10^-i
+            p=p*0.1;
+        }
+        secondes= secondes + (c[n]-48)*p;
+        i++;
+        n++;
+    } while (c[n]!='\0');
+
+     res = degre + (min+secondes)/60; //retourne la valeur final
+
+    return res;
+
+}
+
+void decode_trame(char * trame, Position * P) {
+	int n=17,cpt=0; //n=17 car le codage d'une latitude commence Ã  l'indice 17 ds la trame
+    char lat[10],lon[10];
+    do {
+        lat[cpt]=trame[n]; //reconstitue un char avec les caractère d'une latitude
+        n++;
+        cpt++;
+    } while (trame[n]!=',');
+	cpt=0; //cpt qui balaye le char lat/long
+    n=29; //codage d'une longitude commence Ã  l'indice 29 ds la trame
+    do {  //reconstitue un char avec les caractère d'une longitude
+        lon[cpt]=trame[n];
+        n++;
+        cpt++;
+    } while (trame[n]!=','); //arret à la virgule qui signifie un changement de donnée dans la trame
+
+	(*P).latitude = decode_lat_long(lat); //stockage des valeurs obtenue dans le pointeur de structure poisition P
+	(*P).longitude = decode_lat_long(lon);
+}
+
+float calcule_distance(Position p_1,Position p_2) {
+    float x,y,res;
+    x=(p_2.longitude - p_1.longitude)*cos((p_2.latitude + p_1.latitude) / 2); //Pythagore
+    y=(p_2.latitude - p_1.latitude);
+    res = (sqrt((x*x)+(y*y)))*1.852*60; //*1.852*60 pour passer en km
+    return res;
+}
+
+float calcule_vitesse(Position p_1,Position p_2) {
+    float res;
+    res = calcule_distance(p_1,p_2) * 3600; //*3600 pour passer en km/h, ici la periode est de 1s donc v=d en km/s
+    return res;
+}
+
+int distance_a_la_plus_proche_zone(Position P, Zone r[], int nb_zones, float *d) {
+    int i,n;
+    *d = calcule_distance(P, r[0].rpos); //donne la distance entre P et la 1er zone
+    nb_zones = 0;
+    n=sizeof(*r); //permet d'utiliser la boucle pour en sachant le nombre de zone dans le tableau
+
+    for(i=1;i<n;i++) {
+        if ( calcule_distance(P, r[i].rpos) < *d ) {    //Si en balayant les zones, la distance d devient + petite, alors on a une nouvelle zone dangereuse + proche
+            *d = calcule_distance(P, r[i].rpos);
+            nb_zones = i;
+        }
+    }
+    return nb_zones;
+}
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires_trame_cmp(void){
+ if (5!=5){
+ printf ("Erreur Test unitaire basique.\n");
+ exit(-1);
+ }
+ if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+ printf ("Erreur Test unitaire trame_cmp.\n");
+ exit(-1);
+ }
+ if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+ printf ("Erreur Testtest_decode_trame unitaire trame_cmp.\n");
+ exit(-1);
+ }
+ if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+ printf ("Erreur Test unitaire trame_cmp.\n");
+ exit(-1);
+ }
+ if (trame_cmp("$APRMC...", "GPGGA")!=0){
+ printf ("Erreur Test unitaire trame_cmp.\n");
+ exit(-1);
+ }
+}
+
+void test_decode_int(void) {
+    if (decode_int('0')!=0) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('1')!=1) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('2')!=2) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('3')!=3) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('4')!=4) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('5')!=5) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('6')!=6) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('7')!=7) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('8')!=8) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('9')!=9) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_int('A')!=-1) {
+        printf("erreur");
+        exit(-1);
+    }
+}
+
+
+void test_decode_nombre(void) {
+
+    if (decode_nombre("7541",2)!=75) {
+        printf("erreur");
+        exit(-1);
+    }
+    if (decode_nombre("7541",3)!=754) {
+        printf("erreur");
+        exit(-1);
+    }
+}
+
+
+void test_decode_lat_long(void) {
+    float a,b,c,e;
+    a= 37.387458 - decode_lat_long("3723.2475");
+    c= 45.760703 - decode_lat_long("4545.6422");
+    b=3.11006 - decode_lat_long("00306.6036");
+    e= 3.110077 - decode_lat_long("00306.6046");
+
+    if (a*a > 0.000001){
+        printf("erreur");
+        exit(-1);
+    }
+    if (b*b > 0.000001){
+        printf("erreur2");
+        exit(-1);
+    }
+    if (c*c > 0.000001){
+        printf("erreur2");
+        exit(-1);
+    }
+     if (e*e > 0.000001){
+        printf("erreur2");
+        exit(-1);
+    }
+
+}
+
+void test_decode_trame(void) {
+    float a,b;
+    Position P1;
+
+    decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",&P1);
+    a= 3.110061 - P1.longitude;
+    b= 45.75 - P1.latitude;
+    if ((a*a > 0.000001) && (b*b > 0.000001)) {
+        printf("erreur");
+        exit(-1);
+    }
+
+    decode_trame("$GPGGA,141917.00,4545.0726,N,00306.6039,E,1,05,3.4,499.6,M,,M,,*73",&P1);
+    a= 3.110066 - P1.longitude;
+    b= 45.751209 - P1.latitude;
+    if ((a*a > 0.000001) && (b*b > 0.000001)) {
+        printf("erreur");
+        exit(-1);
+    }
+
+    decode_trame("$GPGGA,141918.00,4545.0968,N,00306.6034,E,1,05,3.4,498.8,M,,M,,*7A",&P1);
+    a= 3.110057 - P1.longitude;
+    b= 45.751614 - P1.latitude;
+    if ((a*a > 0.000001) && (b*b > 0.000001)) {
+        printf("erreur");
+        exit(-1);
+    }
+
+
+    decode_trame("$GPGGA,141919.00,4545.1210,N,00306.6040,E,1,05,3.4,500.2,M,,M,,*77",&P1);
+    a= 3.110067 - P1.longitude;
+    b= 45.752018 - P1.latitude;
+    if ((a*a > 0.000001) && (b*b > 0.000001)) {
+        printf("erreur");
+        exit(-1);
+    }
+
+
+}
+
+
+void test_calcul_distance(void) {
+    Position P1,P2;
+    float a;
+    decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79",&P1);
+    decode_trame("$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75",&P2);
+    a = 0.044932 - calcule_distance(P1,P2);
+
+    if (a*a > 0.000001) {
+        printf("erreur");
+        exit(-1);
+    }
+}
+
+void test_calcul_vitesse(void) {
+    Position P1,P2;
+    float a;
+    decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79",&P1);
+    decode_trame("$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75",&P2);
+    a = 161.756485 - calcule_vitesse(P1,P2);
+    printf("%f",a);
+
+    if (a*a > 0.000001) {
+        printf("erreur");
+        exit(-1);
+    }
+}
+
+void test_distance_a_la_plus_proche_zone(void) {
+    float d;
+    int nb_zones;
+    Position P1;
+
+    decode_trame("$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75", &P1);
+    if (distance_a_la_plus_proche_zone(P1,zones,nb_zones,&d) != 2 ) {
+        printf("erreur");
+        exit(-1);
+    }
+
+}
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+    //tests_unitaires();
+    //test_decode_int();
+    //test_decode_nombre();
+    //test_decode_lat_long();
+    //test_decode_trame();
+    //test_calcul_distance();
+    //test_calcul_vitesse();
+    //test_distance_a_la_plus_proche_zone();
+
+
+    static int cpt=0;
+    float vit; //vitesse en km/h
+    float d; //distance en m
+    int n,nb_zones,alarme=0,seuil=1;
+
+    cpt++;
+
+    if (trame_cmp(trame,"GPGGA") == 1) { //Selectionne une trame valide
+        //printf ("> %s\n",trame);
+            decode_trame(trame,&P2); //stock la 1er trame dans la position P2
+            printf ("> %s\n",trame);
+            if (1) {
+                vit = calcule_vitesse(P2,P1);  //calcule la vitesse entre 2trames
+                n=distance_a_la_plus_proche_zone(P2,zones,nb_zones,&d); //renvoie l indice de la zone la plus proche
+                if ((d<seuil) && (vit>zones[n].vitmax)) { //si la distance a une zone est inferieur a 1m et que la vitesse du conducteur est superieur a la vitesse de la zone
+                    alarme = 1; //activation de l'alarme
+                    printf("Alarme : ON\n");
+                    printf("Route limite a %f, vous roulez a %f \n", zones[n].vitmax, vit); //Indication pour le passager
+                } else {
+                    alarme=0; //Sinon lalarme est off
+                    printf("Alarme : OFF\n");
+                    printf("votre vitesse : %f\n", vit);
+                }
+
+
+            }
+        P1 = P2; //On stock la position actuel dans la position precedente
+    }
+}
+// Ne pas modifier cette fonction
+int main(int argc,char ** argv)
+{
+
+    // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+
+    return 0;
+}
Index: tag/rc_1/ROCHE/gps.log
===================================================================
--- tag/rc_1/ROCHE/gps.log	(nonexistent)
+++ tag/rc_1/ROCHE/gps.log	(revision 438)
@@ -0,0 +1,111 @@
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E
+$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C
+$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E
+$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,99.4,T,,M,0.4,N,0.7,K*57
+$GPZDA,141914.00,01,02,2006,00,00*69
+$GPGSV,3,1,10,01,13,142,46,03,48,144,47,11,41,277,,14,27,104,42*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141915.00,A,4545.6423,N,00306.6039,E,0.6,110.2,010206,,*31
+$GPGLL,4545.6423,N,00306.6039,E,141915.00,A*07
+$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,110.2,T,,M,0.6,N,1.2,K*67
+$GPZDA,141915.00,01,02,2006,00,00*68
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,49,28,15,320,*76
+$GPRMC,141916.00,A,4545.6422,N,00306.6037,E,0.1,211.1,010206,,*3B
+$GPGLL,4545.6422,N,00306.6037,E,141916.00,A*0B
+$GPGGA,141916.00,4545.0484,N,00306.6037,E,1,05,3.4,500.0,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,211.1,T,,M,0.1,N,0.2,K*60
+$GPZDA,141916.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,43*78
+$GPGSV,3,2,10,15,03,077,,18,04,041,44,19,85,271,,20,08,214,*7A
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141917.00,A,4545.6422,N,00306.6039,E,0.3,122.3,010206,,*37
+$GPGLL,4545.6422,N,00306.6039,E,141917.00,A*04
+$GPGGA,141917.00,4545.0726,N,00306.6039,E,1,05,3.4,499.6,M,,M,,*73
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,122.3,T,,M,0.3,N,0.5,K*64
+$GPZDA,141917.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,41*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,39,053,48,28,15,320,*77
+$GPRMC,141918.00,A,4545.6421,N,00306.6034,E,0.5,252.2,010206,,*35
+$GPGLL,4545.6421,N,00306.6034,E,141918.00,A*05
+$GPGGA,141918.00,4545.0968,N,00306.6034,E,1,05,3.4,498.8,M,,M,,*7A
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,252.2,T,,M,0.5,N,1.0,K*63
+$GPZDA,141918.00,01,02,2006,00,00*65
+$GPGSV,3,1,10,01,13,142,45,03,48,144,48,11,41,277,,14,27,104,42*79
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141919.00,A,4545.6420,N,00306.6040,E,0.6,95.2,010206,,*0C
+$GPGLL,4545.6420,N,00306.6040,E,141919.00,A*06
+$GPGGA,141919.00,4545.1210,N,00306.6040,E,1,05,3.4,500.2,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,95.2,T,,M,0.6,N,1.2,K*5B
+$GPZDA,141919.00,01,02,2006,00,00*64
+$GPGSV,3,1,10,01,13,142,46,03,48,144,49,11,41,277,,14,27,104,42*7B
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141920.00,A,4545.6419,N,00306.6039,E,0.2,133.1,010206,,*38
+$GPGLL,4545.6419,N,00306.6039,E,141920.00,A*08
+$GPGGA,141920.00,4545.1410,N,00306.6039,E,1,05,3.4,500.0,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,133.1,T,,M,0.2,N,0.4,K*66
+$GPZDA,141920.00,01,02,2006,00,00*6E
+$GPGSV,3,1,10,01,13,142,45,03,48,144,46,11,41,277,,14,27,104,43*76
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,50,28,15,320,*7F
+$GPRMC,141921.00,A,4545.6419,N,00306.6043,E,0.6,103.1,010206,,*33
+$GPGLL,4545.6419,N,00306.6043,E,141921.00,A*04
+$GPGGA,141921.00,4545.1610,N,00306.6043,E,1,05,3.4,499.8,M,,M,,*70
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,103.1,T,,M,0.6,N,1.1,K*65
+$GPZDA,141921.00,01,02,2006,00,00*6F
+$GPGSV,3,1,10,01,13,142,46,03,48,144,48,11,41,277,,14,27,104,42*7A
+$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141922.00,A,4545.6418,N,00306.6046,E,0.7,96.9,010206,,*00
+$GPGLL,4545.6418,N,00306.6046,E,141922.00,A*03
+$GPGGA,141922.00,4545.1810,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*77
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,96.9,T,,M,0.7,N,1.3,K*53
+$GPZDA,141922.00,01,02,2006,00,00*6C
+$GPGSV,3,1,10,01,13,142,47,03,48,144,46,11,41,277,,14,27,104,43*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,48,28,15,320,*76
+$GPRMC,141923.00,A,4545.6417,N,00306.6046,E,0.3,113.6,010206,,*39
+$GPGLL,4545.6417,N,00306.6046,E,141923.00,A*0D
+$GPGGA,141923.00,4545.2010,N,00306.6046,E,1,05,3.4,500.6,M,,M,,*7D
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,113.6,T,,M,0.3,N,0.7,K*61
+$GPZDA,141923.00,01,02,2006,00,00*6D
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,41*75
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141924.00,A,4545.6416,N,00306.6044,E,0.2,197.7,010206,,*31
+$GPGLL,4545.6416,N,00306.6044,E,141924.00,A*09
+$GPGGA,141924.00,4545.2210,N,00306.6044,E,1,05,3.4,500.5,M,,M,,*79
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,197.7,T,,M,0.2,N,0.4,K*6E
+$GPZDA,141924.00,01,02,2006,00,00*6A
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,43,19,85,271,,20,08,214,*7D
+$GPGSV,3,3,10,22,38,053,49,28,15,320,*77
+$GPRMC,141925.00,A,4545.6415,N,00306.6046,E,0.2,130.8,010206,,*33
+$GPGLL,4545.6415,N,00306.6046,E,141925.00,A*09
+$GPGGA,141925.00,4545.2410,N,00306.6046,E,1,05,3.4,501.4,M,,M,,*7C
+$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39
+$GPVTG,130.8,T,,M,0.2,N,0.5,K*6D
+$GPZDA,141925.00,01,02,2006,00,00*6B
+$GPGSV,3,1,10,01,13,142,45,03,48,144,47,11,41,277,,14,27,104,40*74
+$GPGSV,3,2,10,15,03,077,,18,04,041,41,19,85,271,,20,08,214,*7F
+$GPGSV,3,3,10,22,38,053,47,28,15,320,*79
+$GPRMC,141926.°E,0.2,260.8,010206,,*34
Index: tag/rc_1/ROCHE/trame.c
===================================================================
--- tag/rc_1/ROCHE/trame.c	(nonexistent)
+++ tag/rc_1/ROCHE/trame.c	(revision 438)
@@ -0,0 +1,28 @@
+/* Fichier trames.c - Gestion et decodage des trames */
+/* Ce fichier sera fourni */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "trame.h"
+
+#define FICHIER_TRAMES "gps.log"  /* Par exemple */
+
+#define MAX_FRAME_LENGTH 80
+
+static char trame_buf[MAX_FRAME_LENGTH];
+static FILE *trame_fic;
+
+int trame_init(void)
+{
+    trame_fic = fopen(FICHIER_TRAMES, "r");
+    if (trame_fic)
+        return 1;
+
+    fprintf(stderr, "Impossible d'ouvrir le fichier %s\n", FICHIER_TRAMES);
+    return 0;
+}
+
+char *trame_suivante(void)
+{
+  return fgets(trame_buf, MAX_FRAME_LENGTH-1, trame_fic);
+}
Index: tag/rc_1/ROCHE/sp4a.cbp
===================================================================
--- tag/rc_1/ROCHE/sp4a.cbp	(nonexistent)
+++ tag/rc_1/ROCHE/sp4a.cbp	(revision 438)
@@ -0,0 +1,37 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
+<CodeBlocks_project_file>
+	<FileVersion major="1" minor="6" />
+	<Project>
+		<Option title="sp4a" />
+		<Option pch_mode="2" />
+		<Option compiler="gcc" />
+		<Build>
+			<Target title="Debug">
+				<Option output="sp4a" prefix_auto="1" extension_auto="1" />
+				<Option object_output=".\debug" />
+				<Option type="1" />
+				<Option compiler="gcc" />
+				<Compiler>
+					<Add option="-g" />
+				</Compiler>
+			</Target>
+		</Build>
+		<Compiler>
+			<Add option="-Wall" />
+		</Compiler>
+		<Unit filename="gps.log" />
+		<Unit filename="main.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="trame.h" />
+		<Extensions>
+			<code_completion />
+			<envvars />
+			<debugger />
+			<lib_finder disable_auto="1" />
+		</Extensions>
+	</Project>
+</CodeBlocks_project_file>
Index: tag/rc_1/ROCHE/trame.h
===================================================================
--- tag/rc_1/ROCHE/trame.h	(nonexistent)
+++ tag/rc_1/ROCHE/trame.h	(revision 438)
@@ -0,0 +1,3 @@
+
+int trame_init(void);
+char * trame_suivante(void);